// ************************************************************* 
// Programmbeispiel: 	Temperaturmessung mit TMP100 ueber I2C-Bus
//						Aufloesung 12bit								                           
// Datum: 12.10.2005: mpa										 
//  
                                   

                                   

#include<reg517a.h>
#include<stdio.h>
#include<lcd.h>
#include<i2c.h>

#define TMP100_Adr			0x90			// TMP100 I2C - Adresse 10010000 (schreiben)


// Globale variablen (beginnen mit g...)
char gTXT[25];								// Allgemeiner Textbuffer




// Deklaration der Funktionen


main()
{
int  Temp ;									// Temperaturwerte als Integer (16bit)
unsigned char TempH,TempL;					// Temperaturwerte als Byte (8bit)
float Temperatur;							// Skalierter Temperaturwert als float

i2c_init();									// I2C-Bus initialisieren
init_lcd();									// LCD initialisieren
blank_lcd();								// LCD loeschen


sprintf(gTXT,"TMP100 Sensor:");				// String beschreiben
print_lcd(1,1,gTXT);						// String auf LCD ausgeben. Zeile 1


i2c_start();								// Startbit senden
i2c_write(TMP100_Adr);						// Slave Adresse
i2c_write(0x01);							// Configuration Register schreiben
i2c_write(0x60);							// Setze 12bit Aufloesung (R1,R0 = 1,1)
i2c_stop();									// Stopbit senden

while(1)									// Endlosschleife
	{
	i2c_start();							// Startbit senden
	i2c_write(TMP100_Adr);					// Slave Adresse, schreiben
	i2c_write(0x00);						// Temp Register schreiben
	i2c_stop();								// Stopbit senden
	i2c_start();							// Startbit senden
	i2c_write(TMP100_Adr  | 0x01);			// Slave Adresse mit gesetztem LSB zum lesen
	TempH = i2c_read(1);					// Daten lesen und   ACK schicken 
	TempL = i2c_read(1);					// Daten lesen und   ACK schicken 
	i2c_stop();								// Stopbit senden

	Temp = TempH << 8;						// High Byte nach links schieben (obere 8 bit)
	Temp = Temp | TempL;					// Low Byte dazugeben (untere 8 bit)
	Temp = Temp >> 4;						// 4 bit nach rechts schieben unter Beibehaltung des Vorzeichens
	
	Temperatur = Temp*0.0625;				// Skalieren des Temperaturwertes				
										
	sprintf(gTXT,"%6.4f Grad",Temperatur);	// Temp ausgeben
	print_lcd(2,1,gTXT);					// String auf LCD ausgeben. Zeile 1
	}
}





